package sensorItemCategory

import (
	"encoding/json"
	"git.loafle.net/overflow/commons_go/model/timestamp"
	"git.loafle.net/overflow/overflow_proxy_service/proxy/utils"
)

type SensorItemCategory struct {
	Id          json.Number         `json:"id,Number,omitempty"`
	Name        string              `json:"name,omitempty"`
	Description string              `json:"description,omitempty"`
	CreateDate  timestamp.Timestamp `json:"createDate,omitempty"`
}

type SensorItemCategoryService struct {
}

func NewSensorItemCategoryService() *SensorItemCategoryService {
	return &SensorItemCategoryService{}
}

func (sics *SensorItemCategoryService) Create(sic *SensorItemCategory) (string, error) {
	out, err := utils.InvokeDB("sensorItemCategory", "create", sic)

	if err != nil {
		return "", err
	}
	return out, nil
}
