package target

import (
	"encoding/json"
	"git.loafle.net/overflow/commons_go/model/timestamp"
	"git.loafle.net/overflow/overflow_proxy_service/proxy/member"
	"git.loafle.net/overflow/overflow_proxy_service/proxy"

	"fmt"
	"git.loafle.net/overflow/overflow_proxy_service/proxy/utils"
	"git.loafle.net/overflow/overflow_proxy_service/proxy/session"
)

type Target struct {
	Id json.Number 		`json:"id,Number,omitempty"`
	Ip int64		`json:"ip,omitempty"`
	Port int		`json:"port,omitempty"`
	TargetType string	`json:"targetType,omitempty"`
	VendorName	string	`json:"vendorName,omitempty"`
	Kinds	string		`json:"kinds,omitempty"`
	Version string		`json:"version,omitempty"`
	CreateDate timestamp.Timestamp	`json:"createDate,omitempty"`
	PortType string		`json:"portType,omitempty"`
	Member *member.Member	`json:"member,omitempty"`

}

type TargetService struct {

}

func NewTargetService() *TargetService {
	return &TargetService{}
}

func (t *TargetService)GetModel() interface{} {
	return &Target{}
}

func (t *TargetService)List(tm *Target) (string, error) {

	tm.Member.Id = session.GetSessionMember().Id

	bytes, err := json.Marshal(tm)

	if err != nil {
		return "", err
	}

	m := make(map[string]string)
	m["com.loafle.overflow.target.model.Target"] = string(bytes)

	out, err := proxy.InvokeDB("target", "findAll", m)

	if err != nil {
		return "", err
	}


	return out, err;
}

func (t *TargetService)Create(tm *Target) (string,error) {

	//bytes, err := json.Marshal(tm)
	//
	//if err != nil {
	//	return ""
	//}
	//
	//m := make(map[string]string)
	//m["com.loafle.overflow.target.model.Target"] = string(bytes)
	//
	//out := proxy.InvokeDB("target", "create", m)

	out, err := utils.InvokeDB("target", "create", tm)

	if err != nil {
		return "", err
	}


	return out, nil

}

func (t *TargetService)CreateAll(tmlist *[]*Target) (string,error) {



	outlist := make([]string, 0)
	for _, ttt := range *tmlist {

		ttt.Member = session.GetSessionMember()
		out,err := t.Create(ttt)

		if err != nil {
			return "", err
		}

		outlist = append(outlist, out)
	}

	bytes,err := json.Marshal(outlist)

	if err != nil {
		return "", err
	}

	return string(bytes), nil

}

func (t *TargetService)CreateListTT(tmlist *[]*Target) (string, error) {
	bytes, err := json.Marshal(tmlist)

	if err != nil {
		return "",err
	}

	m := make(map[string]string)
	m["java.util.List"] = string(bytes)

	fmt.Println(string(bytes))
	out, err := proxy.InvokeDB("target", "createAll", m)

	if err != nil {
		return "", err
	}
	//
	//
	return out, nil;
	//return ""
}